part of isyumi;

abstract class UI{

  final List<int> _id;
  
  UI(this._id);
  
}

class _EditListener{
  
  void _appendText(List<int> id){
    print("apptend text $id");
  }
  
}

class Document extends UI implements Appendable{
  
  final Append append; 
  
  Document._(_EditListener _el):super([0]),append = new Append([0],_el);
  
  void _edit(Where where,void f()){
    var tmp = _currentEdit;
    _currentEdit = where;
    f();
    _currentEdit = tmp;
  }
  
  Where _currentEdit;
  
}

abstract class Appendable{
  
  Append get append;
  
}

class Append{
  
  final _EditListener _editListener;
  final List<int> _appendable_id;
  final List<UI> _uis = [];
  
  Append(this._appendable_id,this._editListener);  
  
  void text(void f(Text text)){
    
    Text t = _append((i) => new Text(i));
    
    f(t);
    
    _editListener._appendText(_appendable_id);
    
  }
  
  UI _append(UI f(List<int> i)){
    int id = _getNextID();
    UI ui = f(_appendable_id..add(id));
    _uis.add(ui);
    
    return ui;
    
  }
  
  int _getNextID()=> _uis.length;
  
}

class Text extends UI{
  
  Text(List<int> id):super(id);
  
  set text(String str){
    
  }
  
}

class Div extends UI {
  
  final Append append;
  
  Div(List<int> id,_EditListener _el):super(id),append = new Append(id,_el);
  
}