library isyumi;

import "httpserver.dart";
import "typed_pipe_config.dart";

part "ui.dart";
void onConnection(String host,void f(Client client)){
  
  start_server().listen((connection){
    UrlStruct us = connection.ip.url;
    us.onData.listen((_){
      us.cancel().then((_){
        Client c = new Client(connection.ip,f);
      });
    });
  });
  
}

class _FirstWhere extends Where{
  _FirstWhere():super._([],()=>true);
}


typedef bool State();

class Client extends _FirstWhere{
  
  final Document document;
  final Cookies cookies;
  final URL url;
  final IsyumiPipe ip;
  
  factory Client(IsyumiPipe ip,void f(Client client)){
    URL url = new URL(ip.url.url.value);
    _EditListener el = new _EditListener();
    Document document = new Document._(el);
    
    return new Client._(ip,cookies,url,document,f);
    
  }
  
  Client._(this.ip,this.cookies,this.url,this.document,void f(Client client)){
    ip.url.onData.listen(onURL);
    
    document._edit(this, ()=> f(this));
    
  }
  
  void onURL(e){
      
  }
  
}

class URL{
  String url;
  URL(this.url);
  
  void onChange(String url){ 
    this.url = url;
  }
  
}

class Cookies{
  
}

typedef void _Then();

class Where{
  
  final State _state;
  final List<State> _parent_states;
  final List<Where> _children_wheres = [];
  final List<_Then> _thens = [];
  
  Where._(this._parent_states,this._state);
  
  Where where(State state){
    Where where = new Where._(this._parent_states,state);
    _children_wheres.add(where);
    return where;
  }
  
  void then(void f()){
    _thens.add(f);
  }
  
}